/*
Program:    CONV_ATT wer. 1.1 FREEWARE Copyright (c) M.J.Nowakowski, 1997, 1998

            Program PMMail 1.92 po napotkaniu listu, w ktrego nagwku znajduj si
            wiersze:

            Content-Transfer-Encoding: 8bit / Content-Transfer-Encoding: 7bit
            Mime-Version: 1.0
            Content-Type: text/plain; (<-- NIEPRAWIDOWE! )

            traktuje tre listu jako zacznik o rozszerzeniu .ATT.

            Skrypt CONV_ATT "poprawia" bd programu wysyajcego poczt w nastpujcy sposb:
            - przy przesyaniu 7bit zmienia wiersz z 'Content-Type' do postaci
              'Content-Type: text'
            - przy przesyaniu 8bit uzupenia 'Content-Type: text/plain;' o fraz
              ' charset=ISO-8859-2'.

            Program naley zainstalowa jako filtr na przychodzc poczt. W tym celu trzeba
            w programie PMMail wykona nastpujce czynnoci:
            1. z menu programu wybrac polecenie Account|Utilities Settings;
            2. w oknie dialogowym wybra zakadk "Filters";
            3. klikniciem w przycisk [New] zainicjowa tworzenie nowego filtru;
            4. w polu "Description" poda nazw filtra i sprawdzi, czy zaznaczone jest pole
               wyboru [] Enabled;
            5. zaznaczy przecznik () Complex;
            6. w polu edycyjnym wpisa
                attachment.name.-s=".ATT"
            7. w grupie "Type" zaznaczy pole wyboru [] Incoming;
            8. w grupie "Actions" w najwyszej licie wybra pozycj "REXX exit (background)"
               a nastpnie w wywietlonym z prawej strony polu edycyjnym wpisa nazw pliku
               z niniejszym skryptem wraz z drog do zbioru, np. C:\SOUTHSDE\TOOLS\CONV_ATT.CMD;
            9. klikniciem w przycisk [OK] kolejno w oknie "Edit Filter" oraz "Utilities
               Settings" zakoczy tworzenie filtra.

Autor:      Mirosaw Jan Nowakowski
            ul. lska 68B/6
            80-389 Gdask
            e-mail: nowam@pg.gda.pl

Historia:   1997-10-04 - pierwsza wersja skryptu
            1998-01-27 - zmieniono sposb reakcji w wypadku kodowania 7bit (poprzednio
                         usuwany mia by wiersz 'Mime-Version: 1.0' - tu by bd)

Znane
bdy:      Ikona informujca o obecnoci zacznika nie znika z okna PMMaila.
*/

ARG MailFile .

Call RxFuncAdd 'SysTempFileName', 'RexxUtil', 'SysTempFileName'

Tempfile = SysTempFileName('MSG?????.TMP')

check = STREAM(MailFile,'C','OPEN READ')
check = STREAM(TempFile,'C','OPEN WRITE')

/*
Utworzenie kolejki do zapamitania nagwka.
*/

Header = RXQUEUE('Create')
oq = RXQUEUE('Set', Header)

/*
Odczytanie nagwka, zapamitanie go w kolejce i sprawdzenie, czy kodowanie jest 7-mio
czy 8-mio bitowe
*/

TextLine = ''
IdStr = ''
DO UNTIL Length(TextLine) = 0
    TextLine = LINEIN(MailFile)
    if WORD(TextLine, 1 ) = 'Content-Transfer-Encoding:' then SELECT
        WHEN (WORDPOS('8bit', TextLine) \= 0) then IdStr = '8BIT'
        WHEN (WORDPOS('7bit', TextLine) \= 0) then IdStr = '7BIT'
    END
    Queue TextLine
END

/*
Zapisanie zapamitanego nagwka w pliku tymczasowym z niezbdnymi modyfikacjami.
*/

TextLine = ''
DO QUEUED()
    PARSE PULL TextLine
    if STRIP(TextLine) = 'Content-Type: text/plain;' then SELECT
        WHEN (IdStr = '8BIT') then TextLine = 'Content-Type: text/plain; charset=ISO-8859-2'
        WHEN (IdStr = '7BIT') then TextLine = 'Content-Type: text'
    END
    Call LINEOUT TempFile, TextLine
END

/*
Zapisanie reszty listu do zbioru tymczasowego.
*/

DO WHILE LINES(MailFile) > 0
    check = LINEOUT(TempFile, LINEIN(MailFile))
END

/*
Czynnoci porzdkowe: zamknicie plikw, skasowanie kolejki.
*/

Call STREAM MailFile,'C','CLOSE'
Call STREAM TempFile,'C','CLOSE'
Call RXQUEUE 'Delete', Header

/*
Przekopiowanie pliku tymczasowego do pliku zawierajcego pierwotn tre listu, usunicie
pliku tymczasowego.
*/

'@COPY ' TempFile MailFile ' >NUL'
'@DEL ' TempFile

EXIT

